from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # path (string)
    # expression (Expression)
    from spark_auto_mapper_fhir.complex_types.expression import Expression


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ActivityDefinitionDynamicValue(FhirBackboneElementBase):
    """
    ActivityDefinition.DynamicValue
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        path: FhirString,
        expression: Expression,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param path: The path to the element to be customized. This is the path on the resource
        that will hold the result of the calculation defined by the expression. The
        specified path SHALL be a FHIRPath resolveable on the specified target type of
        the ActivityDefinition, and SHALL consist only of identifiers, constant
        indexers, and a restricted subset of functions. The path is allowed to contain
        qualifiers (.) to traverse sub-elements, as well as indexers ([x]) to traverse
        multiple-cardinality sub-elements (see the [Simple FHIRPath
        Profile](fhirpath.html#simple) for full details).
            :param expression: An expression specifying the value of the customized element.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            path=path,
            expression=expression,
        )
