from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # detailSequence (positiveInt)
    from spark_auto_mapper_fhir.fhir_types.positive_int import FhirPositiveInt

    # noteNumber (positiveInt)
    # adjudication (ClaimResponse.Adjudication)
    from spark_auto_mapper_fhir.backbone_elements.claim_response_adjudication import (
        ClaimResponseAdjudication,
    )

    # subDetail (ClaimResponse.SubDetail)
    from spark_auto_mapper_fhir.backbone_elements.claim_response_sub_detail import (
        ClaimResponseSubDetail,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ClaimResponseDetail(FhirBackboneElementBase):
    """
    ClaimResponse.Detail
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        detailSequence: FhirPositiveInt,
        noteNumber: Optional[FhirList[FhirPositiveInt]] = None,
        adjudication: FhirList[ClaimResponseAdjudication],
        subDetail: Optional[FhirList[ClaimResponseSubDetail]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param detailSequence: A number to uniquely reference the claim detail entry.
            :param noteNumber: The numbers associated with notes below which apply to the adjudication of
        this item.
            :param adjudication: The adjudication results.
            :param subDetail: A sub-detail adjudication of a simple product or service.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            detailSequence=detailSequence,
            noteNumber=noteNumber,
            adjudication=adjudication,
            subDetail=subDetail,
        )
