from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # contentAttachment (Attachment)
    from spark_auto_mapper_fhir.complex_types.attachment import Attachment

    # contentReference (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for contentReference
    from spark_auto_mapper_fhir.resources.document_reference import DocumentReference


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ContractRule(FhirBackboneElementBase):
    """
    Contract.Rule
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        contentAttachment: Optional[Attachment] = None,
        contentReference: Optional[Reference[Union[DocumentReference]]] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param contentAttachment: None
        :param contentReference: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            contentAttachment=contentAttachment,
            contentReference=contentReference,
        )
