from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # type_ (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for type_
    # Import for CodeableConcept for type_
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for type_
    # value (string)
    # name (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class CoverageClass(FhirBackboneElementBase):
    """
    Coverage.Class
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        type_: CodeableConcept[GenericTypeCode],
        value: FhirString,
        name: Optional[FhirString] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param type_: The type of classification for which an insurer-specific class label or number
        and optional name is provided, for example may be used to identify a class of
        coverage or employer group, Policy, Plan.
            :param value: The alphanumeric string value associated with the insurer issued label.
            :param name: A short description for the class.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            type_=type_,
            value=value,
            name=name,
        )
