from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # coverage (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for coverage
    from spark_auto_mapper_fhir.resources.coverage import Coverage

    # inforce (boolean)
    # benefitPeriod (Period)
    from spark_auto_mapper_fhir.complex_types.period import Period

    # item (CoverageEligibilityResponse.Item)
    from spark_auto_mapper_fhir.backbone_elements.coverage_eligibility_response_item import (
        CoverageEligibilityResponseItem,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class CoverageEligibilityResponseInsurance(FhirBackboneElementBase):
    """
    CoverageEligibilityResponse.Insurance
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        coverage: Reference[Union[Coverage]],
        inforce: Optional[FhirBoolean] = None,
        benefitPeriod: Optional[Period] = None,
        item: Optional[FhirList[CoverageEligibilityResponseItem]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param coverage: Reference to the insurance card level information contained in the Coverage
        resource. The coverage issuing insurer will use these details to locate the
        patient's actual coverage within the insurer's information system.
            :param inforce: Flag indicating if the coverage provided is inforce currently if no service
        date(s) specified or for the whole duration of the service dates.
            :param benefitPeriod: The term of the benefits documented in this response.
            :param item: Benefits and optionally current balances, and authorization details by
        category or service.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            coverage=coverage,
            inforce=inforce,
            benefitPeriod=benefitPeriod,
            item=item,
        )
