from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # rating (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for rating
    # Import for CodeableConcept for rating
    from spark_auto_mapper_fhir.value_sets.quality_of_evidence_rating import (
        QualityOfEvidenceRatingCode,
    )

    # End Import for CodeableConcept for rating
    # note (Annotation)
    from spark_auto_mapper_fhir.complex_types.annotation import Annotation

    # certaintySubcomponent (EffectEvidenceSynthesis.CertaintySubcomponent)
    from spark_auto_mapper_fhir.backbone_elements.effect_evidence_synthesis_certainty_subcomponent import (
        EffectEvidenceSynthesisCertaintySubcomponent,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class EffectEvidenceSynthesisCertainty(FhirBackboneElementBase):
    """
    EffectEvidenceSynthesis.Certainty
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        rating: Optional[FhirList[CodeableConcept[QualityOfEvidenceRatingCode]]] = None,
        note: Optional[FhirList[Annotation]] = None,
        certaintySubcomponent: Optional[
            FhirList[EffectEvidenceSynthesisCertaintySubcomponent]
        ] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param rating: A rating of the certainty of the effect estimate.
        :param note: A human-readable string to clarify or explain concepts about the resource.
        :param certaintySubcomponent: A description of a component of the overall certainty.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            rating=rating,
            note=note,
            certaintySubcomponent=certaintySubcomponent,
        )
