from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # description (string)
    # exposureState (ExposureState)
    from spark_auto_mapper_fhir.value_sets.exposure_state import ExposureStateCode

    # variantState (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for variantState
    # Import for CodeableConcept for variantState
    from spark_auto_mapper_fhir.value_sets.evidence_variant_state import (
        EvidenceVariantStateCode,
    )

    # End Import for CodeableConcept for variantState
    # riskEvidenceSynthesis (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for riskEvidenceSynthesis
    from spark_auto_mapper_fhir.resources.risk_evidence_synthesis import (
        RiskEvidenceSynthesis,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class EffectEvidenceSynthesisResultsByExposure(FhirBackboneElementBase):
    """
    EffectEvidenceSynthesis.ResultsByExposure
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        description: Optional[FhirString] = None,
        exposureState: Optional[ExposureStateCode] = None,
        variantState: Optional[CodeableConcept[EvidenceVariantStateCode]] = None,
        riskEvidenceSynthesis: Reference[Union[RiskEvidenceSynthesis]],
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param description: Human-readable summary of results by exposure state.
            :param exposureState: Whether these results are for the exposure state or alternative exposure
        state.
            :param variantState: Used to define variant exposure states such as low-risk state.
            :param riskEvidenceSynthesis: Reference to a RiskEvidenceSynthesis resource.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            description=description,
            exposureState=exposureState,
            variantState=variantState,
            riskEvidenceSynthesis=riskEvidenceSynthesis,
        )
