from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # path (string)
    # min (unsignedInt)
    from spark_auto_mapper_fhir.complex_types.unsigned_int import unsignedInt

    # max (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ElementDefinitionBase(FhirBackboneElementBase):
    """
    ElementDefinition.Base
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        path: FhirString,
        min: unsignedInt,
        max: FhirString,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param path: The Path that identifies the base element - this matches the
        ElementDefinition.path for that element. Across FHIR, there is only one base
        definition of any element - that is, an element definition on a
        [[[StructureDefinition]]] without a StructureDefinition.base.
            :param min: Minimum cardinality of the base element identified by the path.
            :param max: Maximum cardinality of the base element identified by the path.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            path=path,
            min=min,
            max=max,
        )
