from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # discriminator (ElementDefinition.Discriminator)
    from spark_auto_mapper_fhir.backbone_elements.element_definition_discriminator import (
        ElementDefinitionDiscriminator,
    )

    # description (string)
    # ordered (boolean)
    # rules (SlicingRules)
    from spark_auto_mapper_fhir.value_sets.slicing_rules import SlicingRulesCode


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ElementDefinitionSlicing(FhirBackboneElementBase):
    """
    ElementDefinition.Slicing
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        discriminator: Optional[FhirList[ElementDefinitionDiscriminator]] = None,
        description: Optional[FhirString] = None,
        ordered: Optional[FhirBoolean] = None,
        rules: SlicingRulesCode,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param discriminator: Designates which child elements are used to discriminate between the slices
        when processing an instance. If one or more discriminators are provided, the
        value of the child elements in the instance data SHALL completely distinguish
        which slice the element in the resource matches based on the allowed values
        for those elements in each of the slices.
            :param description: A human-readable text description of how the slicing works. If there is no
        discriminator, this is required to be present to provide whatever information
        is possible about how the slices can be differentiated.
            :param ordered: If the matching elements have to occur in the same order as defined in the
        profile.
            :param rules: Whether additional slices are allowed or not. When the slices are ordered,
        profile authors can also say that additional slices are only allowed at the
        end.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            discriminator=discriminator,
            description=description,
            ordered=ordered,
            rules=rules,
        )
