from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # actorId (string)
    # type_ (ExampleScenarioActorType)
    from spark_auto_mapper_fhir.value_sets.example_scenario_actor_type import (
        ExampleScenarioActorTypeCode,
    )

    # name (string)
    # description (markdown)
    from spark_auto_mapper_fhir.fhir_types.markdown import FhirMarkdown


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ExampleScenarioActor(FhirBackboneElementBase):
    """
    ExampleScenario.Actor
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        actorId: FhirString,
        type_: ExampleScenarioActorTypeCode,
        name: Optional[FhirString] = None,
        description: Optional[FhirMarkdown] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param actorId: ID or acronym of actor.
        :param type_: The type of actor - person or system.
        :param name: The name of the actor as shown in the page.
        :param description: The description of the actor.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            actorId=actorId,
            type_=type_,
            name=name,
            description=description,
        )
