from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # title (string)
    # description (markdown)
    from spark_auto_mapper_fhir.fhir_types.markdown import FhirMarkdown

    # step (ExampleScenario.Step)
    from spark_auto_mapper_fhir.backbone_elements.example_scenario_step import (
        ExampleScenarioStep,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ExampleScenarioAlternative(FhirBackboneElementBase):
    """
    ExampleScenario.Alternative
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        title: FhirString,
        description: Optional[FhirMarkdown] = None,
        step: Optional[FhirList[ExampleScenarioStep]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param title: The label to display for the alternative that gives a sense of the
        circumstance in which the alternative should be invoked.
            :param description: A human-readable description of the alternative explaining when the
        alternative should occur rather than the base step.
            :param step: What happens in each alternative option.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            title=title,
            description=description,
            step=step,
        )
