from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # title (string)
    # description (markdown)
    from spark_auto_mapper_fhir.fhir_types.markdown import FhirMarkdown

    # preConditions (markdown)
    # postConditions (markdown)
    # step (ExampleScenario.Step)
    from spark_auto_mapper_fhir.backbone_elements.example_scenario_step import (
        ExampleScenarioStep,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ExampleScenarioProcess(FhirBackboneElementBase):
    """
    ExampleScenario.Process
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        title: FhirString,
        description: Optional[FhirMarkdown] = None,
        preConditions: Optional[FhirMarkdown] = None,
        postConditions: Optional[FhirMarkdown] = None,
        step: Optional[FhirList[ExampleScenarioStep]] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param title: The diagram title of the group of operations.
        :param description: A longer description of the group of operations.
        :param preConditions: Description of initial status before the process starts.
        :param postConditions: Description of final status after the process ends.
        :param step: Each step of the process.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            title=title,
            description=description,
            preConditions=preConditions,
            postConditions=postConditions,
            step=step,
        )
