from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # versionId (string)
    # description (markdown)
    from spark_auto_mapper_fhir.fhir_types.markdown import FhirMarkdown


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ExampleScenarioVersion(FhirBackboneElementBase):
    """
    ExampleScenario.Version
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        versionId: FhirString,
        description: FhirMarkdown,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param versionId: The identifier of a specific version of a resource.
        :param description: The description of the resource version.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            versionId=versionId,
            description=description,
        )
