from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # focal (boolean)
    # coverage (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for coverage
    from spark_auto_mapper_fhir.resources.coverage import Coverage

    # preAuthRef (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ExplanationOfBenefitInsurance(FhirBackboneElementBase):
    """
    ExplanationOfBenefit.Insurance
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        focal: FhirBoolean,
        coverage: Reference[Union[Coverage]],
        preAuthRef: Optional[FhirList[FhirString]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param focal: A flag to indicate that this Coverage is to be used for adjudication of this
        claim when set to true.
            :param coverage: Reference to the insurance card level information contained in the Coverage
        resource. The coverage issuing insurer will use these details to locate the
        patient's actual coverage within the insurer's information system.
            :param preAuthRef: Reference numbers previously provided by the insurer to the provider to be
        quoted on subsequent claims containing services or products related to the
        prior authorization.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            focal=focal,
            coverage=coverage,
            preAuthRef=preAuthRef,
        )
