from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # path (string)
    # sliceName (string)
    # min (integer)
    # max (string)
    # description (string)
    # target (GraphDefinition.Target)
    from spark_auto_mapper_fhir.backbone_elements.graph_definition_target import (
        GraphDefinitionTarget,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class GraphDefinitionLink(FhirBackboneElementBase):
    """
    GraphDefinition.Link
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        path: Optional[FhirString] = None,
        sliceName: Optional[FhirString] = None,
        min: Optional[FhirInteger] = None,
        max: Optional[FhirString] = None,
        description: Optional[FhirString] = None,
        target: Optional[FhirList[GraphDefinitionTarget]] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param path: A FHIR expression that identifies one of FHIR References to other resources.
        :param sliceName: Which slice (if profiled).
        :param min: Minimum occurrences for this link.
        :param max: Maximum occurrences for this link.
        :param description: Information about why this link is of interest in this graph definition.
        :param target: Potential target for the link.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            path=path,
            sliceName=sliceName,
            min=min,
            max=max,
            description=description,
            target=target,
        )
