from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.date_time import FhirDateTime
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # date (dateTime)
    # detail (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for detail
    from spark_auto_mapper_fhir.resources.observation import Observation

    # reported (boolean)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ImmunizationReaction(FhirBackboneElementBase):
    """
    Immunization.Reaction
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        date: Optional[FhirDateTime] = None,
        detail: Optional[Reference[Union[Observation]]] = None,
        reported: Optional[FhirBoolean] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param date: Date of reaction to the immunization.
        :param detail: Details of the reaction.
        :param reported: Self-reported indicator.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            date=date,
            detail=detail,
            reported=reported,
        )
