from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # name (string)
    # title (string)
    # anchor (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ImplementationGuidePage1(FhirBackboneElementBase):
    """
    ImplementationGuide.Page1
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        name: FhirString,
        title: Optional[FhirString] = None,
        anchor: Optional[FhirList[FhirString]] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param name: Relative path to the page.
        :param title: Label for the page intended for human display.
        :param anchor: The name of an anchor available on the page.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            name=name,
            title=title,
            anchor=anchor,
        )
