from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId
from spark_auto_mapper_fhir.resources.resource import Resource

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # reference (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for reference
    # relativePath (url)
    from spark_auto_mapper_fhir.fhir_types.url import FhirUrl

    # exampleBoolean (boolean)
    # exampleCanonical (canonical)
    from spark_auto_mapper_fhir.fhir_types.canonical import FhirCanonical


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ImplementationGuideResource1(FhirBackboneElementBase):
    """
    ImplementationGuide.Resource1
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        reference: Reference[Union[Resource]],
        relativePath: Optional[FhirUrl] = None,
        exampleBoolean: Optional[FhirBoolean] = None,
        exampleCanonical: Optional[FhirCanonical] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param reference: Where this resource is found.
        :param relativePath: The relative path for primary page for this resource within the IG.
        :param exampleBoolean: None
        :param exampleCanonical: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            reference=reference,
            relativePath=relativePath,
            exampleBoolean=exampleBoolean,
            exampleCanonical=exampleCanonical,
        )
