from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # code (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for code
    # Import for CodeableConcept for code
    from spark_auto_mapper_fhir.value_sets.measure_population_type import (
        MeasurePopulationTypeCode,
    )

    # End Import for CodeableConcept for code
    # description (string)
    # criteria (Expression)
    from spark_auto_mapper_fhir.complex_types.expression import Expression


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MeasurePopulation(FhirBackboneElementBase):
    """
    Measure.Population
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        code: Optional[CodeableConcept[MeasurePopulationTypeCode]] = None,
        description: Optional[FhirString] = None,
        criteria: Expression,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param code: The type of population criteria.
            :param description: The human readable description of this population criteria.
            :param criteria: An expression that specifies the criteria for the population, typically the
        name of an expression in a library.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            code=code,
            description=description,
            criteria=criteria,
        )
