from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # dosage (MedicationKnowledge.Dosage)
    from spark_auto_mapper_fhir.backbone_elements.medication_knowledge_dosage import (
        MedicationKnowledgeDosage,
    )

    # patientCharacteristics (MedicationKnowledge.PatientCharacteristics)
    from spark_auto_mapper_fhir.backbone_elements.medication_knowledge_patient_characteristics import (
        MedicationKnowledgePatientCharacteristics,
    )

    # indicationCodeableConcept (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for indicationCodeableConcept
    # Import for CodeableConcept for indicationCodeableConcept
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for indicationCodeableConcept
    # indicationReference (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for indicationReference
    from spark_auto_mapper_fhir.resources.observation_definition import (
        ObservationDefinition,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MedicationKnowledgeAdministrationGuidelines(FhirBackboneElementBase):
    """
    MedicationKnowledge.AdministrationGuidelines
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        dosage: Optional[FhirList[MedicationKnowledgeDosage]] = None,
        patientCharacteristics: Optional[
            FhirList[MedicationKnowledgePatientCharacteristics]
        ] = None,
        indicationCodeableConcept: Optional[CodeableConcept[GenericTypeCode]] = None,
        indicationReference: Optional[Reference[Union[ObservationDefinition]]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param dosage: Dosage for the medication for the specific guidelines.
            :param patientCharacteristics: Characteristics of the patient that are relevant to the administration
        guidelines (for example, height, weight, gender, etc.).
            :param indicationCodeableConcept: None
            :param indicationReference: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            dosage=dosage,
            patientCharacteristics=patientCharacteristics,
            indicationCodeableConcept=indicationCodeableConcept,
            indicationReference=indicationReference,
        )
