from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # country (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for country
    # Import for CodeableConcept for country
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for country
    # jurisdiction (CodeableConcept)
    # End Import for References for jurisdiction
    # Import for CodeableConcept for jurisdiction
    # End Import for CodeableConcept for jurisdiction
    # language (CodeableConcept)
    # End Import for References for language
    # Import for CodeableConcept for language
    # End Import for CodeableConcept for language


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MedicinalProductCountryLanguage(FhirBackboneElementBase):
    """
    MedicinalProduct.CountryLanguage
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        country: CodeableConcept[GenericTypeCode],
        jurisdiction: Optional[CodeableConcept[GenericTypeCode]] = None,
        language: CodeableConcept[GenericTypeCode],
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param country: Country code for where this name applies.
        :param jurisdiction: Jurisdiction code for where this name applies.
        :param language: Language code for this name.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            country=country,
            jurisdiction=jurisdiction,
            language=language,
        )
