from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # code (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for code
    # Import for CodeableConcept for code
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for code
    # withdrawalPeriod (MedicinalProductPharmaceutical.WithdrawalPeriod)
    from spark_auto_mapper_fhir.backbone_elements.medicinal_product_pharmaceutical_withdrawal_period import (
        MedicinalProductPharmaceuticalWithdrawalPeriod,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MedicinalProductPharmaceuticalTargetSpecies(FhirBackboneElementBase):
    """
    MedicinalProductPharmaceutical.TargetSpecies
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        code: CodeableConcept[GenericTypeCode],
        withdrawalPeriod: Optional[
            FhirList[MedicinalProductPharmaceuticalWithdrawalPeriod]
        ] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param code: Coded expression for the species.
            :param withdrawalPeriod: A species specific time during which consumption of animal product is not
        appropriate.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            code=code,
            withdrawalPeriod=withdrawalPeriod,
        )
