from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # score (integer)
    # numTP (integer)
    # numFP (integer)
    # numFN (integer)
    # precision (decimal)
    from spark_auto_mapper_fhir.fhir_types.decimal import FhirDecimal

    # sensitivity (decimal)
    # fMeasure (decimal)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MolecularSequenceRoc(FhirBackboneElementBase):
    """
    MolecularSequence.Roc
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        score: Optional[FhirList[FhirInteger]] = None,
        numTP: Optional[FhirList[FhirInteger]] = None,
        numFP: Optional[FhirList[FhirInteger]] = None,
        numFN: Optional[FhirList[FhirInteger]] = None,
        precision: Optional[FhirList[FhirDecimal]] = None,
        sensitivity: Optional[FhirList[FhirDecimal]] = None,
        fMeasure: Optional[FhirList[FhirDecimal]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param score: Invidual data point representing the GQ (genotype quality) score threshold.
            :param numTP: The number of true positives if the GQ score threshold was set to "score"
        field value.
            :param numFP: The number of false positives if the GQ score threshold was set to "score"
        field value.
            :param numFN: The number of false negatives if the GQ score threshold was set to "score"
        field value.
            :param precision: Calculated precision if the GQ score threshold was set to "score" field value.
            :param sensitivity: Calculated sensitivity if the GQ score threshold was set to "score" field
        value.
            :param fMeasure: Calculated fScore if the GQ score threshold was set to "score" field value.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            score=score,
            numTP=numTP,
            numFP=numFP,
            numFN=numFN,
            precision=precision,
            sensitivity=sensitivity,
            fMeasure=fMeasure,
        )
