from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # variantType (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for variantType
    # Import for CodeableConcept for variantType
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for variantType
    # exact (boolean)
    # length (integer)
    # outer (MolecularSequence.Outer)
    from spark_auto_mapper_fhir.backbone_elements.molecular_sequence_outer import (
        MolecularSequenceOuter,
    )

    # inner (MolecularSequence.Inner)
    from spark_auto_mapper_fhir.backbone_elements.molecular_sequence_inner import (
        MolecularSequenceInner,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class MolecularSequenceStructureVariant(FhirBackboneElementBase):
    """
    MolecularSequence.StructureVariant
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        variantType: Optional[CodeableConcept[GenericTypeCode]] = None,
        exact: Optional[FhirBoolean] = None,
        length: Optional[FhirInteger] = None,
        outer: Optional[MolecularSequenceOuter] = None,
        inner: Optional[MolecularSequenceInner] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param variantType: Information about chromosome structure variation DNA change type.
            :param exact: Used to indicate if the outer and inner start-end values have the same
        meaning.
            :param length: Length of the variant chromosome.
            :param outer: Structural variant outer.
            :param inner: Structural variant inner.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            variantType=variantType,
            exact=exact,
            length=length,
            outer=outer,
            inner=inner,
        )
