from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # type_ (NamingSystemIdentifierType)
    from spark_auto_mapper_fhir.value_sets.naming_system_identifier_type import (
        NamingSystemIdentifierTypeCode,
    )

    # value (string)
    # preferred (boolean)
    # comment (string)
    # period (Period)
    from spark_auto_mapper_fhir.complex_types.period import Period


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class NamingSystemUniqueId(FhirBackboneElementBase):
    """
    NamingSystem.UniqueId
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        type_: NamingSystemIdentifierTypeCode,
        value: FhirString,
        preferred: Optional[FhirBoolean] = None,
        comment: Optional[FhirString] = None,
        period: Optional[Period] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param type_: Identifies the unique identifier scheme used for this particular identifier.
            :param value: The string that should be sent over the wire to identify the code system or
        identifier system.
            :param preferred: Indicates whether this identifier is the "preferred" identifier of this type.
            :param comment: Notes about the past or intended usage of this identifier.
            :param period: Identifies the period of time over which this identifier is considered
        appropriate to refer to the naming system.  Outside of this window, the
        identifier might be non-deterministic.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            type_=type_,
            value=value,
            preferred=preferred,
            comment=comment,
            period=period,
        )
