from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # schedule (Timing)
    from spark_auto_mapper_fhir.backbone_elements.timing import Timing

    # quantity (Quantity)
    from spark_auto_mapper_fhir.complex_types.quantity import Quantity

    # rateQuantity (Quantity)
    # rateRatio (Ratio)
    from spark_auto_mapper_fhir.complex_types.ratio import Ratio


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class NutritionOrderAdministration(FhirBackboneElementBase):
    """
    NutritionOrder.Administration
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        schedule: Optional[Timing] = None,
        quantity: Optional[Quantity] = None,
        rateQuantity: Optional[Quantity] = None,
        rateRatio: Optional[Ratio] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param schedule: The time period and frequency at which the enteral formula should be delivered
        to the patient.
            :param quantity: The volume of formula to provide to the patient per the specified
        administration schedule.
            :param rateQuantity: None
            :param rateRatio: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            schedule=schedule,
            quantity=quantity,
            rateQuantity=rateQuantity,
            rateRatio=rateRatio,
        )
