from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # modifier (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for modifier
    # Import for CodeableConcept for modifier
    from spark_auto_mapper_fhir.value_sets.texture_modifier_codes import (
        TextureModifierCodesCode,
    )

    # End Import for CodeableConcept for modifier
    # foodType (CodeableConcept)
    # End Import for References for foodType
    # Import for CodeableConcept for foodType
    from spark_auto_mapper_fhir.value_sets.texture_modified_food_type_codes import (
        TextureModifiedFoodTypeCodesCode,
    )

    # End Import for CodeableConcept for foodType


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class NutritionOrderTexture(FhirBackboneElementBase):
    """
    NutritionOrder.Texture
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        modifier: Optional[CodeableConcept[TextureModifierCodesCode]] = None,
        foodType: Optional[CodeableConcept[TextureModifiedFoodTypeCodesCode]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param modifier: Any texture modifications (for solid foods) that should be made, e.g. easy to
        chew, chopped, ground, and pureed.
            :param foodType: The food type(s) (e.g. meats, all foods)  that the texture modification
        applies to.  This could be all foods types.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            modifier=modifier,
            foodType=foodType,
        )
