from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # customaryUnit (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for customaryUnit
    # Import for CodeableConcept for customaryUnit
    from spark_auto_mapper_fhir.value_sets.ucum_codes import UCUMCodesCode

    # End Import for CodeableConcept for customaryUnit
    # unit (CodeableConcept)
    # End Import for References for unit
    # Import for CodeableConcept for unit
    # End Import for CodeableConcept for unit
    # conversionFactor (decimal)
    from spark_auto_mapper_fhir.fhir_types.decimal import FhirDecimal

    # decimalPrecision (integer)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ObservationDefinitionQuantitativeDetails(FhirBackboneElementBase):
    """
    ObservationDefinition.QuantitativeDetails
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        customaryUnit: Optional[CodeableConcept[UCUMCodesCode]] = None,
        unit: Optional[CodeableConcept[UCUMCodesCode]] = None,
        conversionFactor: Optional[FhirDecimal] = None,
        decimalPrecision: Optional[FhirInteger] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param customaryUnit: Customary unit used to report quantitative results of observations conforming
        to this ObservationDefinition.
            :param unit: SI unit used to report quantitative results of observations conforming to this
        ObservationDefinition.
            :param conversionFactor: Factor for converting value expressed with SI unit to value expressed with
        customary unit.
            :param decimalPrecision: Number of digits after decimal separator when the results of such observations
        are of type Quantity.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            customaryUnit=customaryUnit,
            unit=unit,
            conversionFactor=conversionFactor,
            decimalPrecision=decimalPrecision,
        )
