from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId
from spark_auto_mapper_fhir.fhir_types.uri import FhirUri

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # linkId (string)
    # definition (uri)
    # text (string)
    # answer (QuestionnaireResponse.Answer)
    from spark_auto_mapper_fhir.backbone_elements.questionnaire_response_answer import (
        QuestionnaireResponseAnswer,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class QuestionnaireResponseItem(FhirBackboneElementBase):
    """
    QuestionnaireResponse.Item
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        linkId: FhirString,
        definition: Optional[FhirUri] = None,
        text: Optional[FhirString] = None,
        answer: Optional[FhirList[QuestionnaireResponseAnswer]] = None,
        item: Optional[FhirList[QuestionnaireResponseItem]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param linkId: The item from the Questionnaire that corresponds to this item in the
        QuestionnaireResponse resource.
            :param definition: A reference to an [[[ElementDefinition]]] that provides the details for the
        item.
            :param text: Text that is displayed above the contents of the group or as the text of the
        question being answered.
            :param answer: The respondent's answer(s) to the question.
            :param item: Questions or sub-groups nested beneath a question or group.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            linkId=linkId,
            definition=definition,
            text=text,
            answer=answer,
            item=item,
        )
