from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # name (string)
    # type_ (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for type_
    # Import for CodeableConcept for type_
    from spark_auto_mapper_fhir.value_sets.research_study_objective_type import (
        ResearchStudyObjectiveTypeCode,
    )

    # End Import for CodeableConcept for type_


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ResearchStudyObjective(FhirBackboneElementBase):
    """
    ResearchStudy.Objective
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        name: Optional[FhirString] = None,
        type_: Optional[CodeableConcept[ResearchStudyObjectiveTypeCode]] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param name: Unique, human-readable label for this objective of the study.
        :param type_: The kind of study objective.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            name=name,
            type_=type_,
        )
