from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # type_ (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for type_
    # Import for CodeableConcept for type_
    from spark_auto_mapper_fhir.value_sets.precision_estimate_type import (
        PrecisionEstimateTypeCode,
    )

    # End Import for CodeableConcept for type_
    # level (decimal)
    from spark_auto_mapper_fhir.fhir_types.decimal import FhirDecimal

    # from_ (decimal)
    # to (decimal)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class RiskEvidenceSynthesisPrecisionEstimate(FhirBackboneElementBase):
    """
    RiskEvidenceSynthesis.PrecisionEstimate
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        type_: Optional[CodeableConcept[PrecisionEstimateTypeCode]] = None,
        level: Optional[FhirDecimal] = None,
        from_: Optional[FhirDecimal] = None,
        to: Optional[FhirDecimal] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param type_: Examples include confidence interval and interquartile range.
        :param level: Use 95 for a 95% confidence interval.
        :param from_: Lower bound of confidence interval.
        :param to: Upper bound of confidence interval.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            type_=type_,
            level=level,
            from_=from_,
            to=to,
        )
