from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId
from spark_auto_mapper_fhir.fhir_types.uri import FhirUri

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # identity (id)
    from spark_auto_mapper_fhir.complex_types.id import id

    # uri (uri)
    # name (string)
    # comment (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class StructureDefinitionMapping(FhirBackboneElementBase):
    """
    StructureDefinition.Mapping
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        identity: id,
        uri: Optional[FhirUri] = None,
        name: Optional[FhirString] = None,
        comment: Optional[FhirString] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param identity: An Internal id that is used to identify this mapping set when specific
        mappings are made.
            :param uri: An absolute URI that identifies the specification that this mapping is
        expressed to.
            :param name: A name for the specification that is being mapped to.
            :param comment: Comments about this mapping, including version notes, issues, scope
        limitations, and other important notes for usage.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            identity=identity,
            uri=uri,
            name=name,
            comment=comment,
        )
