from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # name (id)
    from spark_auto_mapper_fhir.complex_types.id import id

    # variable (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class StructureMapDependent(FhirBackboneElementBase):
    """
    StructureMap.Dependent
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        name: id,
        variable: FhirList[FhirString],
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param name: Name of a rule or group to apply.
        :param variable: Variable to pass to the rule or group.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            name=name,
            variable=variable,
        )
