from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # valueId (id)
    from spark_auto_mapper_fhir.complex_types.id import id

    # valueString (string)
    # valueBoolean (boolean)
    # valueInteger (integer)
    # valueDecimal (decimal)
    from spark_auto_mapper_fhir.fhir_types.decimal import FhirDecimal


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class StructureMapParameter(FhirBackboneElementBase):
    """
    StructureMap.Parameter
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        valueId: Optional[id] = None,
        valueString: Optional[FhirString] = None,
        valueBoolean: Optional[FhirBoolean] = None,
        valueInteger: Optional[FhirInteger] = None,
        valueDecimal: Optional[FhirDecimal] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param valueId: None
        :param valueString: None
        :param valueBoolean: None
        :param valueInteger: None
        :param valueDecimal: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            valueId=valueId,
            valueString=valueString,
            valueBoolean=valueBoolean,
            valueInteger=valueInteger,
            valueDecimal=valueDecimal,
        )
