from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # lowLimit (Quantity)
    from spark_auto_mapper_fhir.complex_types.quantity import Quantity

    # highLimit (Quantity)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class SubstanceAmountReferenceRange(FhirBackboneElementBase):
    """
    SubstanceAmount.ReferenceRange
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        lowLimit: Optional[Quantity] = None,
        highLimit: Optional[Quantity] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param lowLimit: Lower limit possible or expected.
        :param highLimit: Upper limit possible or expected.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            lowLimit=lowLimit,
            highLimit=highLimit,
        )
