from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # connectivity (string)
    # identifier (Identifier)
    from spark_auto_mapper_fhir.complex_types.identifier import Identifier

    # name (string)
    # residueSite (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class SubstanceNucleicAcidLinkage(FhirBackboneElementBase):
    """
    SubstanceNucleicAcid.Linkage
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        connectivity: Optional[FhirString] = None,
        identifier: Optional[Identifier] = None,
        name: Optional[FhirString] = None,
        residueSite: Optional[FhirString] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param connectivity: The entity that links the sugar residues together should also be captured for
        nearly all naturally occurring nucleic acid the linkage is a phosphate group.
        For many synthetic oligonucleotides phosphorothioate linkages are often seen.
        Linkage connectivity is assumed to be 3’-5’. If the linkage is either 3’-3’ or
        5’-5’ this should be specified.
            :param identifier: Each linkage will be registered as a fragment and have an ID.
            :param name: Each linkage will be registered as a fragment and have at least one name. A
        single name shall be assigned to each linkage.
            :param residueSite: Residues shall be captured as described in 5.3.6.8.3.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            connectivity=connectivity,
            identifier=identifier,
            name=name,
            residueSite=residueSite,
        )
