from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # target (Identifier)
    from spark_auto_mapper_fhir.complex_types.identifier import Identifier

    # type_ (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for type_
    # Import for CodeableConcept for type_
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for type_
    # interaction (CodeableConcept)
    # End Import for References for interaction
    # Import for CodeableConcept for interaction
    # End Import for CodeableConcept for interaction
    # organism (CodeableConcept)
    # End Import for References for organism
    # Import for CodeableConcept for organism
    # End Import for CodeableConcept for organism
    # organismType (CodeableConcept)
    # End Import for References for organismType
    # Import for CodeableConcept for organismType
    # End Import for CodeableConcept for organismType
    # amountType (CodeableConcept)
    # End Import for References for amountType
    # Import for CodeableConcept for amountType
    # End Import for CodeableConcept for amountType
    # source (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for source
    from spark_auto_mapper_fhir.resources.document_reference import DocumentReference

    # amountQuantity (Quantity)
    from spark_auto_mapper_fhir.complex_types.quantity import Quantity

    # amountRange (Range)
    from spark_auto_mapper_fhir.complex_types.range import Range

    # amountString (string)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class SubstanceReferenceInformationTarget(FhirBackboneElementBase):
    """
    SubstanceReferenceInformation.Target
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        target: Optional[Identifier] = None,
        type_: Optional[CodeableConcept[GenericTypeCode]] = None,
        interaction: Optional[CodeableConcept[GenericTypeCode]] = None,
        organism: Optional[CodeableConcept[GenericTypeCode]] = None,
        organismType: Optional[CodeableConcept[GenericTypeCode]] = None,
        amountType: Optional[CodeableConcept[GenericTypeCode]] = None,
        source: Optional[FhirList[Reference[Union[DocumentReference]]]] = None,
        amountQuantity: Optional[Quantity] = None,
        amountRange: Optional[Range] = None,
        amountString: Optional[FhirString] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param target: Todo.
        :param type_: Todo.
        :param interaction: Todo.
        :param organism: Todo.
        :param organismType: Todo.
        :param amountType: Todo.
        :param source: Todo.
        :param amountQuantity: None
        :param amountRange: None
        :param amountString: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            target=target,
            type_=type_,
            interaction=interaction,
            organism=organism,
            organismType=organismType,
            amountType=amountType,
            source=source,
            amountQuantity=amountQuantity,
            amountRange=amountRange,
            amountString=amountString,
        )
