from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # operation (TestReport.Operation)
    from spark_auto_mapper_fhir.backbone_elements.test_report_operation import (
        TestReportOperation,
    )

    # assert_ (TestReport.Assert)
    from spark_auto_mapper_fhir.backbone_elements.test_report_assert import (
        TestReportAssert,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class TestReportAction(FhirBackboneElementBase):
    """
    TestReport.Action
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        operation: Optional[TestReportOperation] = None,
        assert_: Optional[TestReportAssert] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param operation: The operation performed.
        :param assert_: The results of the assertion performed on the previous operations.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            operation=operation,
            assert_=assert_,
        )
