from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # action (TestReport.Action)
    from spark_auto_mapper_fhir.backbone_elements.test_report_action import (
        TestReportAction,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class TestReportSetup(FhirBackboneElementBase):
    """
    TestReport.Setup
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        action: FhirList[TestReportAction],
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param action: Action would contain either an operation or an assertion.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            action=action,
        )
