from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # name (string)
    # description (string)
    # action (TestReport.Action1)
    from spark_auto_mapper_fhir.backbone_elements.test_report_action1 import (
        TestReportAction1,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class TestReportTest(FhirBackboneElementBase):
    """
    TestReport.Test
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        name: Optional[FhirString] = None,
        description: Optional[FhirString] = None,
        action: FhirList[TestReportAction1],
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param name: The name of this test used for tracking/logging purposes by test engines.
            :param description: A short description of the test used by test engines for tracking and
        reporting purposes.
            :param action: Action would contain either an operation or an assertion.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            name=name,
            description=description,
            action=action,
        )
