from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # operation (TestScript.Operation)
    from spark_auto_mapper_fhir.backbone_elements.test_script_operation import (
        TestScriptOperation,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class TestScriptAction2(FhirBackboneElementBase):
    """
    TestScript.Action2
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        operation: TestScriptOperation,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param operation: An operation would involve a REST request to a server.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            operation=operation,
        )
