from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # index (integer)
    # profile (Coding)
    from spark_auto_mapper_fhir.complex_types.coding import Coding

    # End Import for References for profile
    # Import for CodeableConcept for profile
    from spark_auto_mapper_fhir.value_sets.test_script_profile_destination_type import (
        TestScriptProfileDestinationTypeCode,
    )

    # End Import for CodeableConcept for profile


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class TestScriptDestination(FhirBackboneElementBase):
    """
    TestScript.Destination
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        index: FhirInteger,
        profile: Coding[TestScriptProfileDestinationTypeCode],
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param index: Abstract name given to a destination server in this test script.  The name is
        provided as a number starting at 1.
            :param profile: The type of destination profile the test system supports.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            index=index,
            profile=profile,
        )
