from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # name (string)
    # defaultValue (string)
    # description (string)
    # expression (string)
    # headerField (string)
    # hint (string)
    # path (string)
    # sourceId (id)
    from spark_auto_mapper_fhir.complex_types.id import id


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class TestScriptVariable(FhirBackboneElementBase):
    """
    TestScript.Variable
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        name: FhirString,
        defaultValue: Optional[FhirString] = None,
        description: Optional[FhirString] = None,
        expression: Optional[FhirString] = None,
        headerField: Optional[FhirString] = None,
        hint: Optional[FhirString] = None,
        path: Optional[FhirString] = None,
        sourceId: Optional[id] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param name: Descriptive name for this variable.
            :param defaultValue: A default, hard-coded, or user-defined value for this variable.
            :param description: A free text natural language description of the variable and its purpose.
            :param expression: The FHIRPath expression to evaluate against the fixture body. When variables
        are defined, only one of either expression, headerField or path must be
        specified.
            :param headerField: Will be used to grab the HTTP header field value from the headers that
        sourceId is pointing to.
            :param hint: Displayable text string with hint help information to the user when entering a
        default value.
            :param path: XPath or JSONPath to evaluate against the fixture body.  When variables are
        defined, only one of either expression, headerField or path must be specified.
            :param sourceId: Fixture to evaluate the XPath/JSONPath expression or the headerField  against
        within this variable.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            name=name,
            defaultValue=defaultValue,
            description=description,
            expression=expression,
            headerField=headerField,
            hint=hint,
            path=path,
            sourceId=sourceId,
        )
