from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # code (code)
    from spark_auto_mapper_fhir.complex_types.code import code

    # display (string)
    # designation (ValueSet.Designation)
    from spark_auto_mapper_fhir.backbone_elements.value_set_designation import (
        ValueSetDesignation,
    )


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ValueSetConcept(FhirBackboneElementBase):
    """
    ValueSet.Concept
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        code: code,
        display: Optional[FhirString] = None,
        designation: Optional[FhirList[ValueSetDesignation]] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param code: Specifies a code for the concept to be included or excluded.
            :param display: The text to display to the user for this concept in the context of this
        valueset. If no display is provided, then applications using the value set use
        the display specified for the code by the system.
            :param designation: Additional representations for this concept when used in this value set -
        other languages, aliases, specialized purposes, used for particular purposes,
        etc.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            code=code,
            display=display,
            designation=designation,
        )
