from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.boolean import FhirBoolean
from spark_auto_mapper_fhir.fhir_types.date_time import FhirDateTime
from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.integer import FhirInteger
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId
from spark_auto_mapper_fhir.fhir_types.uri import FhirUri

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # name (string)
    # valueString (string)
    # valueBoolean (boolean)
    # valueInteger (integer)
    # valueDecimal (decimal)
    from spark_auto_mapper_fhir.fhir_types.decimal import FhirDecimal

    # valueUri (uri)
    # valueCode (code)
    from spark_auto_mapper_fhir.complex_types.code import code

    # valueDateTime (dateTime)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ValueSetParameter(FhirBackboneElementBase):
    """
    ValueSet.Parameter
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        name: FhirString,
        valueString: Optional[FhirString] = None,
        valueBoolean: Optional[FhirBoolean] = None,
        valueInteger: Optional[FhirInteger] = None,
        valueDecimal: Optional[FhirDecimal] = None,
        valueUri: Optional[FhirUri] = None,
        valueCode: Optional[code] = None,
        valueDateTime: Optional[FhirDateTime] = None,
    ) -> None:
        """

            :param id_: id of resource
            :param extension: extensions
            :param name: Name of the input parameter to the $expand operation; may be a server-assigned
        name for additional default or other server-supplied parameters used to
        control the expansion process.
            :param valueString: None
            :param valueBoolean: None
            :param valueInteger: None
            :param valueDecimal: None
            :param valueUri: None
            :param valueCode: None
            :param valueDateTime: None
        """
        super().__init__(
            id_=id_,
            extension=extension,
            name=name,
            valueString=valueString,
            valueBoolean=valueBoolean,
            valueInteger=valueInteger,
            valueDecimal=valueDecimal,
            valueUri=valueUri,
            valueCode=valueCode,
            valueDateTime=valueDateTime,
        )
