from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.fhir_types.string import FhirString
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # organization (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for organization
    from spark_auto_mapper_fhir.resources.organization import Organization

    # identityCertificate (string)
    # attestationSignature (Signature)
    from spark_auto_mapper_fhir.complex_types.signature import Signature


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class VerificationResultValidator(FhirBackboneElementBase):
    """
    VerificationResult.Validator
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        organization: Reference[Union[Organization]],
        identityCertificate: Optional[FhirString] = None,
        attestationSignature: Optional[Signature] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param organization: Reference to the organization validating information.
        :param identityCertificate: A digital identity certificate associated with the validator.
        :param attestationSignature: Signed assertion by the validator that they have validated the information.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            organization=organization,
            identityCertificate=identityCertificate,
            attestationSignature=attestationSignature,
        )
