from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList

from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_complex_type_base import FhirComplexTypeBase

if TYPE_CHECKING:
    pass
    # low (Quantity)
    from spark_auto_mapper_fhir.complex_types.quantity import Quantity

    # high (Quantity)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class Range(FhirComplexTypeBase):
    """
    Range
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        low: Optional[Quantity] = None,
        high: Optional[Quantity] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param low: The low limit. The boundary is inclusive.
        :param high: The high limit. The boundary is inclusive.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            low=low,
            high=high,
        )
