from __future__ import annotations
from typing import Optional, TYPE_CHECKING

from spark_auto_mapper_fhir.fhir_types.list import FhirList

from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_complex_type_base import FhirComplexTypeBase

if TYPE_CHECKING:
    pass
    # numerator (Quantity)
    from spark_auto_mapper_fhir.complex_types.quantity import Quantity

    # denominator (Quantity)


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class Ratio(FhirComplexTypeBase):
    """
    Ratio
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        numerator: Optional[Quantity] = None,
        denominator: Optional[Quantity] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param numerator: The value of the numerator.
        :param denominator: The value of the denominator.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            numerator=numerator,
            denominator=denominator,
        )
