from __future__ import annotations

from spark_auto_mapper_fhir.fhir_types.uri import FhirUri

from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode
from spark_auto_mapper.type_definitions.defined_types import AutoMapperTextInputType


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class AllSecurityLabelsCode(GenericTypeCode):
    """
    All Security Labels
    From: http://hl7.org/fhir/ValueSet/security-labels in valuesets.xml
        A single value set for all security labels defined by FHIR.
    """

    def __init__(self, value: AutoMapperTextInputType):
        super().__init__(value=value)

    """
    http://hl7.org/fhir/ValueSet/security-labels
    """
    codeset: FhirUri = "http://hl7.org/fhir/ValueSet/security-labels"
