from __future__ import annotations

from spark_auto_mapper_fhir.fhir_types.uri import FhirUri

from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode
from spark_auto_mapper.type_definitions.defined_types import AutoMapperTextInputType


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ContextOfUseValueSetCode(GenericTypeCode):
    """
    Context of Use ValueSet
    From: http://hl7.org/fhir/ValueSet/use-context in valuesets.xml
        This value set defines a base set of codes that can be used to indicate that
    the content in a resource was developed with a focus and intent of supporting
    use within particular contexts.
    """

    def __init__(self, value: AutoMapperTextInputType):
        super().__init__(value=value)

    """
    http://snomed.info/sct
    """
    codeset: FhirUri = "http://snomed.info/sct"
    """
    urn:iso:std:iso:3166
    """
    codeset_2: FhirUri = "urn:iso:std:iso:3166"
    """
    http://unstats.un.org/unsd/methods/m49/m49.htm
    """
    codeset_3: FhirUri = "http://unstats.un.org/unsd/methods/m49/m49.htm"
    """
    http://nucc.org/provider-taxonomy
    """
    codeset_4: FhirUri = "http://nucc.org/provider-taxonomy"
