from __future__ import annotations

from spark_auto_mapper_fhir.fhir_types.uri import FhirUri

from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode
from spark_auto_mapper.type_definitions.defined_types import AutoMapperTextInputType


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class ObservationReferenceRangeAppliesToCodesCode(GenericTypeCode):
    """
    ObservationReferenceRangeAppliesToCodes
    From: http://hl7.org/fhir/ValueSet/referencerange-appliesto in valuesets.xml
        This value set defines a set of codes that can be used to indicate the
    particular target population the reference range applies to.
    """

    def __init__(self, value: AutoMapperTextInputType):
        super().__init__(value=value)

    """
    http://snomed.info/sct
    """
    codeset: FhirUri = "http://snomed.info/sct"


class ObservationReferenceRangeAppliesToCodesCodeValues:
    """
    From: http://hl7.org/fhir/ValueSet/referencerange-appliesto in valuesets.xml
    """

    _248153007 = ObservationReferenceRangeAppliesToCodesCode("248153007")
    """
    From: http://hl7.org/fhir/ValueSet/referencerange-appliesto in valuesets.xml
    """
    _248152002 = ObservationReferenceRangeAppliesToCodesCode("248152002")
    """
    From: http://hl7.org/fhir/ValueSet/referencerange-appliesto in valuesets.xml
    """
    _77386006 = ObservationReferenceRangeAppliesToCodesCode("77386006")
