from __future__ import annotations
from typing import Optional, TYPE_CHECKING, Union

from spark_auto_mapper_fhir.fhir_types.list import FhirList
from spark_auto_mapper_fhir.extensions.extension_base import ExtensionBase
from spark_auto_mapper_fhir.fhir_types.id import FhirId

from spark_auto_mapper_fhir.base_types.fhir_backbone_element_base import (
    FhirBackboneElementBase,
)

if TYPE_CHECKING:
    pass
    # geneSequenceOrigin (CodeableConcept)
    from spark_auto_mapper_fhir.complex_types.codeable_concept import CodeableConcept

    # End Import for References for geneSequenceOrigin
    # Import for CodeableConcept for geneSequenceOrigin
    from spark_auto_mapper_fhir.value_sets.generic_type import GenericTypeCode

    # End Import for CodeableConcept for geneSequenceOrigin
    # gene (CodeableConcept)
    # End Import for References for gene
    # Import for CodeableConcept for gene
    # End Import for CodeableConcept for gene
    # source (Reference)
    from spark_auto_mapper_fhir.complex_types.reference import Reference

    # Imports for References for source
    from spark_auto_mapper_fhir.resources.document_reference import DocumentReference


# This file is auto-generated by generate_classes so do not edit manually
# noinspection PyPep8Naming
class SubstanceReferenceInformationGene(FhirBackboneElementBase):
    """
    SubstanceReferenceInformation.Gene
    """

    # noinspection PyPep8Naming
    def __init__(
        self,
        *,
        id_: Optional[FhirId] = None,
        extension: Optional[FhirList[ExtensionBase]] = None,
        geneSequenceOrigin: Optional[CodeableConcept[GenericTypeCode]] = None,
        gene: Optional[CodeableConcept[GenericTypeCode]] = None,
        source: Optional[FhirList[Reference[Union[DocumentReference]]]] = None,
    ) -> None:
        """

        :param id_: id of resource
        :param extension: extensions
        :param geneSequenceOrigin: Todo.
        :param gene: Todo.
        :param source: Todo.
        """
        super().__init__(
            id_=id_,
            extension=extension,
            geneSequenceOrigin=geneSequenceOrigin,
            gene=gene,
            source=source,
        )
